SystemOrganization addCategory: #'PBE-LightsOut'!

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOCell methodsFor: 'initialization' stamp: 'RoxanaLimachi 9/23/2012 18:56'!
initialize
  "manda un mensaje a su superclase"
  super initialize.
  "No ponemos ninguna etiqueta"
  self label: ''.
  "Ajustamos el tamanho del borde de la celda"
  self borderWidth: 2. 
  "Borde de la Figura , formamos un cuadrado"
   "Cada celda tiene 30 de ancho x 30 de alto"
  bounds:= 0@0 corner:20@20.
  "Que tal si le ponemos azul, para cuando este desactivado"
  offColor:= Color lightBlue .
  "y cuando esta activo?"
  onColor:= Color lightGray .
  "Se puede cambiar la forma de las esquinas de "
  "cuadradas por redondeadas"
  "self useRoundedCorners."
  self useSquareCorners. "Usamos esquinas de forma cuadrada"
  self turnOff
! !

!LOCell methodsFor: 'accessing' stamp: 'NuryYulenyArosquipaYanque 9/20/2012 13:21'!
mouseAction 
^mouseAction ! !

!LOCell methodsFor: 'accessing' stamp: 'NuryYulenyArosquipaYanque 9/20/2012 13:14'!
mouseAction: aBlock
^mouseAction := aBlock! !

!LOCell methodsFor: 'event handling' stamp: 'NuryYulenyArosquipaYanque 9/20/2012 13:23'!
mouseUp: anEvent
mouseAction value! !

BorderedMorph subclass: #LOGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOGame methodsFor: 'initialization' stamp: 'RoxanaLimachi 9/23/2012 17:55'!
cellsPerSide 
  "El nmero de celdas en ancho y alto del juego Ej. 20 de ancho por 20 de alto"
  ^20! !

!LOGame methodsFor: 'initialization' stamp: 'RoxanaLimachi 9/23/2012 18:53'!
initialize 
   "Declaracin de variables locales"
   | sampleCell width height  n|
   super initialize . "Manda un mensaje a la super clase"
   "Self se refiere al receptor 	al mtodo de ejecucin actual"
    n:= self cellsPerSide. "Self es una pseudo-variable,THIS en Java???"
   sampleCell  := LOCell  new. "sampleCell es un objeto de la clase LoCell"
   width := sampleCell width.
   height := sampleCell height.
   self bounds: (5@5 extent: ((width*n)@(height*n))+(2*self borderWidth)). 
   cells:=Matrix new: n tabulate: [:i :j | self newCellAt: i at: j ].! !

!LOGame methodsFor: 'event handling' stamp: 'NuryYulenyArosquipaYanque 9/20/2012 13:38'!
mouseMove: anEvent! !

!LOGame methodsFor: 'initialization' stamp: 'NuryYulenyArosquipaYanque 9/20/2012 13:34'!
newCellAt: i at: j
   "Create a cell for position (i,j) and add it to my on - screen
     representation at the appropriate screen position. Answer the new cell"
   | c origin | 
   c := LOCell new.
   origin := self innerBounds origin .
   self addMorph: c.
   c position: ((i-1)*c width)@((j-1)*c height)+origin.
   c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
    ^c! !

!LOGame methodsFor: 'game logic' stamp: 'NuryYulenyArosquipaYanque 9/20/2012 13:11'!
toggleNeighboursOfCellAt: i at: j
   (i>1) ifTrue: [(cells at: i-1 at:j) toggleState].
   (i<self cellsPerSide) ifTrue: [(cells at: i+1 at:j) toggleState].
   (j>1) ifTrue: [(cells at: i at:j-1) toggleState].
   (i<self cellsPerSide) ifTrue: [(cells at: i at:j+1) toggleState].! !
